/*******************************************************************************
 * Copyright(c) 2022 dongke All rights reserved. / Confidential
 * 类的信息：
 *		1.程序名称：
 *		2.新建资金账户
 * 编辑履历：
 *		作者				日期					版本				修改内容
 *		王英杰		   2024-2-12	   1.00		   	    
 *******************************************************************************/
const mixins = require('@/mixins/index.js')
const Constants = require('@/utils/Constants')
const app = getApp()
Page({
    mixins: [mixins],
    /**
     * 页面的初始数据
     */
    data: {
        cardList: ['main','center','other'],
        contentObj: {
            main: [{ //账户编码
                    code: 'macCode',
                    type: 'str',
                    readonly: true,
                    title: mixins.$t('accountCode')
                },
                { //账户类别
                    code: 'macType',
                    name: 'macTypeName',
                    title: mixins.$t("accountCategory"),
                    type: 'choose',
                    urlKey:'accountCategory' ,
                    required: true, 
                  },
                { //账户名称
                    code: 'macName',
                    type: 'str',
                    required: true,
                    title: mixins.$t('accountName')
                },
                { //收款码
                    code: 'file',
                    type: 'uploader',
                    title: mixins.$t('commodityPicture')
                  },
                { //默认账户
                    code: 'flgDefault',
                    type: 'switch',
                    title: mixins.$t('defaultAccount')
                } 
            ],
            center: [
                  { //期初余额
                    code: 'balance',
                    type: 'number',
                    title: mixins.$t('openingBalance')
                  },
                  { code: 'accDate', type: 'date', title: mixins.$t('balanceDate') }
            ],
            other: [ //备注
                { code: 'remarks', type: 'textarea', title: mixins.$t('remarks') }
            ],
        },
        // 路由
        routeObjName: 'moneyAccount',
    },
    /**
     * @desc   : 处理数据-保存和查询后的逻辑
     * @author : 王英杰
     * @date   : 2024/1/26 11:46
     */
    handleData() {
        wx.navigateBack({
            data: 1
        })
    },
 
      /**
     * @desc   : dk-form choose类型组件回调
     * @author : 王英杰
     * @date   : 2024/1/26 11:46
     */ 
    chooseData(e){
        console.log("t",e,this.data.formData);
        let formData = JSON.parse(this.data.formData)
        let code = e.detail.code
        let data = e.detail.data.data
        if(code == "macType"){ //账户类别
          formData.macType = data.id
          formData.macTypeName = data.name
        } 
        this.setData({
          formData: JSON.stringify(formData)
        })
      },
    /**
     * @desc : 保存的參數設置
     * @date : 2024/2/1 15:49
     * @author : 王英杰
     */
    setParams(params) {
        let formData = JSON.parse(this.data.formData)
        params =  formData
        params.balance = params.balance||0
        params.initBalance = params.balance
        params.makeStaff = app.globalData.user.staffId
        params.orgId = app.globalData.user.orgId
        params.staffId = app.globalData.user.staffId 
       params.accDate=  params.accDate || new Date().toDateStr()  
        return params
    },

    /**
     * @desc : 保存数据服务
     * @date : 2024/2/1 15:49
     * @author : 王英杰
     */
    saveData() {
        if (this.data.formMode == Constants.formMode.edit) {
            return this.excute(this.data.service, this.data.service.update, this.data.params)
        } else {
            return this.excute(this.data.service, this.data.service.insert, this.data.params)
        }

    },
    /**
     * @desc : 给表单赋值
     * @date : 2024/2/1 15:49
     * @author : 王英杰
     */
    setValuesByEdit(data) {
        data.roleIds = (data.roleIds && data.roleIds.length > 0) ? data.roleIds.join(',') : undefined
        this.setData({
            formData: JSON.stringify(data)
        })

    },

  /**
   * @desc : 给表单赋值
   * @date : 2024/2/1 15:49
   * @author : 王英杰
   */
  setValuesByEdit(data) { 
    data.serviceCategories = (data.serviceCategories && data.serviceCategories.length > 0) ? data.serviceCategories.join(',') : undefined
    data.brandIds = (data.brandIds && data.brandIds.length > 0) ? data.brandIds.split(',') : undefined
    this.setData({
      formData: JSON.stringify(data)
    }) 

  },
    /**
     * @desc : 页面加载数据方法
     * @date : 2024/2/1 15:49
     * @author : 王英杰
     */
    loadInit() {
        if (this.data.formMode == Constants.formMode.edit) {
            wx.setNavigationBarTitle({
                title: mixins.$t('editFundAccount'),
            })
        } else {
            wx.setNavigationBarTitle({
                title: mixins.$t('newFundAccount'),
            })
        }
    },
})